Bug 60821

Summary: [chromium] Don't split long skinny layers into multiple tiles
Product: WebKit Reporter: Adrienne Walker <enne>
Component: New BugsAssignee: Adrienne Walker <enne>
Status: RESOLVED FIXED    
Severity: Normal CC: enne, jamesr, nduca, vangelis
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
Patch
none
Patch jamesr: review+

Description Adrienne Walker 2011-05-13 17:17:43 PDT
[chromium] Don't split scrollbars into multiple tiles
Comment 1 Adrienne Walker 2011-05-13 17:18:43 PDT
Created attachment 93537 [details]
Patch
Comment 2 Adrienne Walker 2011-05-13 17:20:10 PDT
I will probably also need to rebaseline a small number of tests as a result of this change, but I thought I would upload the code first.
Comment 3 James Robinson 2011-05-13 17:28:45 PDT
Comment on attachment 93537 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=93537&action=review

> Source/WebCore/ChangeLog:5
> +        [chromium] Don't split scrollbars into multiple tiles

this doesn't precisely describe what the patch does - this patch changes the behavior for layers that are <512px in one dimension and >512 in another.  Can you make the title be something more generic and describe the implications for scrollbar layers in particular in the extended description part of the ChangeLog?

> Source/WebCore/platform/graphics/chromium/ContentLayerChromium.cpp:173
> +    // (e.g. scrollbars) that are Nx1 tiles to minimize wasted texture space.

this doesn't actually change the amount of space used by textures (in terms of the # of pixels), just the # of textures right?

> Source/WebCore/platform/graphics/chromium/ContentLayerChromium.cpp:176
> +    const bool autoTiled = (layerSize.width() > maxUntiledSize && layerSize.height() > maxUntiledSize)
> +            || (layerSize.width() > maxUntiledSize && layerSize.height() > defaultTileSize)
> +            || (layerSize.height() > maxUntiledSize && layerSize.width() > defaultTileSize);

can you use some descriptively named temporary bools to try to make this more readable?
Comment 4 Adrienne Walker 2011-05-19 10:25:45 PDT
(In reply to comment #3)
> (From update of attachment 93537 [details])
> View in context: https://bugs.webkit.org/attachment.cgi?id=93537&action=review
> 
> > Source/WebCore/ChangeLog:5
> > +        [chromium] Don't split scrollbars into multiple tiles
> 
> this doesn't precisely describe what the patch does - this patch changes the behavior for layers that are <512px in one dimension and >512 in another.  Can you make the title be something more generic and describe the implications for scrollbar layers in particular in the extended description part of the ChangeLog?

Sure.  You're right that this needs better explanation than I gave it.

> > Source/WebCore/platform/graphics/chromium/ContentLayerChromium.cpp:173
> > +    // (e.g. scrollbars) that are Nx1 tiles to minimize wasted texture space.
> 
> this doesn't actually change the amount of space used by textures (in terms of the # of pixels), just the # of textures right?

No, it changes both.  The tiler (for simplicity) uses a fixed tile size.  So, using 256x256 tiles for a 512x15 scrollbar will waste 512x241 texels.  The tile size is the one knob the tiler exposes to tweak both the number of textures and the amount of wasted texture space.

> > Source/WebCore/platform/graphics/chromium/ContentLayerChromium.cpp:176
> > +    const bool autoTiled = (layerSize.width() > maxUntiledSize && layerSize.height() > maxUntiledSize)
> > +            || (layerSize.width() > maxUntiledSize && layerSize.height() > defaultTileSize)
> > +            || (layerSize.height() > maxUntiledSize && layerSize.width() > defaultTileSize);
> 
> can you use some descriptively named temporary bools to try to make this more readable?

Sure.
Comment 5 Adrienne Walker 2011-05-19 12:10:30 PDT
Created attachment 94098 [details]
Patch
Comment 6 James Robinson 2011-05-31 19:40:08 PDT
Comment on attachment 94098 [details]
Patch

R=me.  Guessing that you'll rebaseline compositing/geometry/fixed-position.html + vertical-scroll-composited.html + fixed-position-ancestor-clip.html after landing?
Comment 7 Adrienne Walker 2011-06-01 10:37:16 PDT
Committed r87822: <http://trac.webkit.org/changeset/87822>
Comment 8 James Robinson 2011-06-01 19:56:51 PDT
You also redded these: compositing/geometry/horizontal-scroll-composited.html,platform/chromium/compositing/layout-width-change.html

looks like filtering diffs on the scrollbar layer:

http://test-results.appspot.com/dashboards/flakiness_dashboard.html#tests=compositing%2Fgeometry%2Fhorizontal-scroll-composited.html%2Cplatform%2Fchromium%2Fcompositing%2Flayout-width-change.html&showLargeExpectations=true&showExpectations=true&group=%40ToT%20GPU%20Mesa%20-%20chromium.org

so probably just a rebaseline
Comment 9 Adrienne Walker 2011-06-02 09:51:06 PDT
Committed r87922: <http://trac.webkit.org/changeset/87922>
Comment 10 Adrienne Walker 2011-06-02 10:42:19 PDT
Committed r87928: <http://trac.webkit.org/changeset/87928>
Comment 11 Adrienne Walker 2011-06-02 10:43:31 PDT
(In reply to comment #8)
> You also redded these: compositing/geometry/horizontal-scroll-composited.html,platform/chromium/compositing/layout-width-change.html

Thanks.  Silly tests being marked as broken on Linux so that I don't notice them when running tests locally.  :(